package com.jtauber.fop.fo;

import java.util.Hashtable;
import java.util.Enumeration;

import com.jtauber.fop.layout.Document;

import com.jtauber.fop.apps.FOPException;

/**
 * base class for representation of formatting objects and their processing
 */
public class FObj extends FONode {
	private String currentText;
	public PropertyList properties;

	public String foName;

	public static class Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new FObj(doc, parent, propertyList);
		}
	}
	protected FObj(Document doc, FObj parent, PropertyList propertyList) {
		super(doc, parent);
		this.properties = propertyList;
		this.currentText = null;
	}
	protected void addCharacters(Document doc, char data[], int start, int length) {
		if (this.currentText == null)
			currentText = new String(data,start,length);
		else
			currentText += new String(data,start,length);
	}
	protected void addChild(FObj child) {
		finishText();
		children.addElement(child);
	}
	protected void end(Document doc) {
		finishText();
	}
	protected void finishText() {
		if (this.currentText != null) {
			children.addElement(new FOText(this.doc,currentText,this));
			currentText = null;
		}
	}
	public void layout() throws FOPException {
		Enumeration e = children.elements();
		while (e.hasMoreElements()) {
			((FONode)e.nextElement()).layout();
		}
	}
public static Maker maker() {
	return new Maker();
}
}