package com.jtauber.fop.fo.flow;

import com.jtauber.fop.fo.*;

import com.jtauber.fop.fo.pagination.PageSequence;

import java.util.Hashtable;
import java.util.Enumeration;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.fo.properties.ID;
import com.jtauber.fop.fo.properties.FlowName;
import com.jtauber.fop.apps.FOPException;

public class Flow extends FObj {
	
	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new Flow(doc, parent,propertyList);
		}
	}

	PageSequence pageSequence;

	protected Flow(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc,parent,propertyList);
		this.foName =  "fo:flow";

		if (parent.foName.equals("fo:page-sequence")) {
			this.pageSequence = (PageSequence)parent;
		} else {
			throw new FOPException("fo:flow must be child of fo:page-sequence, not "+parent.foName);
		}
		pageSequence.setFlow(this);
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public void go() throws FOPException {
		this.layout();
	}
public void layout() throws FOPException {
	Enumeration e = children.elements();
	while (e.hasMoreElements()) {
		((FONode) e.nextElement()).layout();
	}
}

public static FObj.Maker maker() {
	return new Flow.Maker();
}
}