package com.jtauber.fop.fo.flow;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;


import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.FontState;


import com.jtauber.fop.apps.FOPException;

import java.util.Enumeration;

public class PageNumber extends FObj {
	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new PageNumber(doc, parent, propertyList);
		}
	}
	public PageNumber(Document doc, FObj parent, PropertyList propertyList) {
		super(doc,parent,propertyList);
		this.foName = "fo:page-number";
	}
	public void layout() throws FOPException {
		String fontFamily = ((FontFamily)this.properties.get("font-family")).string();
		String fontStyle = ((FontStyle)this.properties.get("font-style")).string();
		String fontWeight = ((FontWeight)this.properties.get("font-weight")).string();
		int fontSize = ((FontSize)this.properties.get("font-size")).length().value();
		
		FontState fs = new FontState(doc.getFontInfo(),fontFamily,fontStyle,fontWeight,fontSize);

		doc.addText(fs, doc.getPageNumber());
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new PageNumber.Maker();
}
}