package com.jtauber.fop.fo.flow;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.fo.pagination.PageSequence;

import com.jtauber.fop.layout.Document;

import com.jtauber.fop.apps.FOPException;				   

import java.util.Enumeration;

public class StaticContent extends FObj {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new StaticContent(doc, parent,propertyList);
		}
	}

	PageSequence pageSequence;
	protected StaticContent(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc,parent,propertyList);
		this.foName =  "fo:static-content";

		if (parent.foName.equals("fo:page-sequence")) {
			this.pageSequence = (PageSequence)parent;
		} else {
			throw new FOPException("fo:static-content must be child of fo:page-sequence, not "+parent.foName);
		}
		String flowName = ((FlowName)this.properties.get("flow-name")).string();

		pageSequence.setStaticContent(flowName,this);
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public void layout() throws FOPException {
		Enumeration e = children.elements();
		while (e.hasMoreElements()) {
			((FONode)e.nextElement()).layout();
		}
	}
public static FObj.Maker maker() {
	return new StaticContent.Maker();
}
}