package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import java.util.Hashtable;

import com.jtauber.fop.layout.Document;

import com.jtauber.fop.apps.FOPException;				   

public class LayoutMasterSet extends FObj {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new LayoutMasterSet(doc, parent,propertyList);
		}
	}

	private Hashtable layoutMasters;
	private Root root;
	
	protected LayoutMasterSet(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent,propertyList);
		this.foName = "fo:layout-master-set";

		this.layoutMasters = new Hashtable();
		if (parent.foName.equals("fo:root")) {
			this.root = (Root)parent;
			root.setLayoutMasterSet(this);
		} else {
			throw new FOPException("fo:layout-master-set must be child of fo:root, not "+parent.foName);
		}
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void addLayoutMaster(String masterName, SimplePageMaster layoutMaster) {
		this.layoutMasters.put(masterName, layoutMaster);
	}
	protected void finishText() {}
	protected SimplePageMaster getLayoutMaster(String masterName) {
		return (SimplePageMaster)this.layoutMasters.get(masterName);
	}
public static FObj.Maker maker() {
	return new LayoutMasterSet.Maker();
}
}