package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.fo.flow.Flow;
import com.jtauber.fop.fo.flow.StaticContent;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.Page;
import com.jtauber.fop.layout.PageMasterFactory;


import com.jtauber.fop.apps.FOPException;				   

import java.util.Hashtable;

public class PageSequence extends FObj {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new PageSequence(doc, parent,propertyList);
		}
	}

	private Root root;
	private SequenceSpecification sequenceSpecification;
	private Flow flow;
	private StaticContent staticBefore;
	private StaticContent staticAfter;
	private LayoutMasterSet layoutMasterSet;
	
	protected PageSequence(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent,propertyList);
		this.foName = "fo:page-sequence";

		if (parent.foName.equals("fo:root")) {
			this.root = (Root)parent;
			this.root.addPageSequence(this);
		} else {
			throw new FOPException("fo:page-sequence must be child of fo:root, not "+parent.foName);
		}
		layoutMasterSet = root.getLayoutMasterSet();
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	protected void layout(Document doc) throws FOPException {
		// layout this page sequence
		
		// while there is still stuff in the flow, ask the sequence-specification for a new page
	    
		if (this.sequenceSpecification == null) {
			throw new FOPException("fo:page-sequence is missing an fo:sequence-specification");
		}
		
		PageMasterFactory pmf = this.sequenceSpecification.getFirstPageMasterFactory();
		doc.setPageMasterFactory(pmf);
		doc.setStaticBefore(this.staticBefore);
		doc.setStaticAfter(this.staticAfter);
		doc.startPage();
		this.flow.go();
		doc.endPage();
	}
public static FObj.Maker maker() {
	return new PageSequence.Maker();
}
	public void setFlow(Flow flow) {
		this.flow = flow;
	}
	protected void setSequenceSpecification(SequenceSpecification sequenceSpecification) {
		this.sequenceSpecification = sequenceSpecification;
		sequenceSpecification.setLayoutMasterSet(this.layoutMasterSet);
	}
	public void setStaticContent(String name, StaticContent staticContent) {
		if (name.equals("xsl-before")) {
			this.staticBefore = staticContent;
		} else if (name.equals("xsl-after")) {
			this.staticAfter = staticContent;
		} else {
			System.err.println("WARNING: this version of FOP only supports static-content in region-before and region-after");
		}
	}
}