package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.PageMasterFactory;
import com.jtauber.fop.layout.AlternatingPageMasterFactory;
import com.jtauber.fop.layout.PageMaster;

import com.jtauber.fop.apps.FOPException;				   

public class SequenceSpecifierAlternating extends SequenceSpecifier {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new SequenceSpecifierAlternating(doc, parent, propertyList);
		}
	}
	
	private SequenceSpecification sequenceSpecification;
	private LayoutMasterSet layoutMasterSet;
	private AlternatingPageMasterFactory pageMasterFactory;
	
	protected SequenceSpecifierAlternating(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		PageMaster pf, pe, po;

		this.foName =  "fo:sequence-specifer-alternating";
		
		if (parent.foName.equals("fo:sequence-specification")) {
			this.sequenceSpecification = (SequenceSpecification)parent;
			this.layoutMasterSet = this.sequenceSpecification.getLayoutMasterSet();
		} else {
			throw new FOPException("fo:sequence-specifier-alternating must be child of fo:sequence-specification, not "+parent.foName);
		}
		String pageMasterFirst = ((PageMasterFirst)this.properties.get("page-master-first")).string();
		String pageMasterOdd = ((PageMasterOdd)this.properties.get("page-master-odd")).string();
		String pageMasterEven = ((PageMasterEven)this.properties.get("page-master-even")).string();
		try {
			pf = this.layoutMasterSet.getLayoutMaster(pageMasterFirst).getPageMaster();
			pe = this.layoutMasterSet.getLayoutMaster(pageMasterEven).getPageMaster();
			po = this.layoutMasterSet.getLayoutMaster(pageMasterOdd).getPageMaster();
			this.pageMasterFactory = new AlternatingPageMasterFactory(pf,pe,po);
		} catch (java.lang.NullPointerException e) {
			throw new FOPException("at least one of the page-master names in sequence-specifier-alternating is not in layout-master-set");
		}
		this.sequenceSpecification.addSequenceSpecifier(this);
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public PageMasterFactory getPageMasterFactory() {
		return this.pageMasterFactory;
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new SequenceSpecifierAlternating.Maker();
}
}