package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.PageMasterFactory;
import com.jtauber.fop.layout.RepeatingPageMasterFactory;
import com.jtauber.fop.layout.PageMaster;

import com.jtauber.fop.apps.FOPException;				   

public class SequenceSpecifierRepeating extends SequenceSpecifier {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new SequenceSpecifierRepeating(doc, parent, propertyList);
		}
	}

	private SequenceSpecification sequenceSpecification;
	private LayoutMasterSet layoutMasterSet;
	private RepeatingPageMasterFactory pageMasterFactory;
	
	protected SequenceSpecifierRepeating(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		PageMaster pf, pr;

		this.foName =  "fo:sequence-specifer-repeating";
		
		if (parent.foName.equals("fo:sequence-specification")) {
			this.sequenceSpecification = (SequenceSpecification)parent;
			this.layoutMasterSet = this.sequenceSpecification.getLayoutMasterSet();
		} else {
			throw new FOPException("fo:sequence-specifier-repeating must be child of fo:sequence-specification, not "+parent.foName);
		}

		String pageMasterFirst = ((PageMasterFirst)this.properties.get("page-master-first")).string();
		String pageMasterRepeating = ((PageMasterRepeating)this.properties.get("page-master-repeating")).string();
		try {
			pf = this.layoutMasterSet.getLayoutMaster(pageMasterFirst).getPageMaster();
			pr = this.layoutMasterSet.getLayoutMaster(pageMasterRepeating).getPageMaster();
			this.pageMasterFactory = new RepeatingPageMasterFactory(pf,pr);
		} catch (java.lang.NullPointerException e) {
			throw new FOPException("at least one of the page-master names in sequence-specifier-repeating is not in layout-master-set");
		}
		this.sequenceSpecification.addSequenceSpecifier(this);
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public PageMasterFactory getPageMasterFactory() {
		return this.pageMasterFactory;
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new SequenceSpecifierRepeating.Maker();
}
}