package com.jtauber.fop.layout;

import java.util.Vector;

abstract public class Area extends Box {

	// nominal font size and nominal font family incorporated in fontState
	protected FontState fontState;
	protected Vector children;
	
	protected int writingMode;
	
	protected int maxHeight; // max size in line-progression-direction
	protected int currentHeight;

	protected int contentRectangleWidth;

	protected int allocationWidth;
	protected int y_size;

	public Area() {
	}
	public Area (FontState fontState) {
		this.fontState = fontState;
		this.children = new Vector();
	}
	protected void addChild(Box child) {
		this.children.addElement(child);
		child.parent = this;
	}
	public void addDisplaySpace(int size) {
		this.addChild(new DisplaySpace(size));
		this.currentHeight += size;
	}
	public void end() {
	}
public Vector getChildren() {
	return this.children;
}
public FontState getFontState() {
	return this.fontState;
}
	public int getHeight() {
		return currentHeight;
	}
	public int getWidth() {
		return allocationWidth;
	}
	public void increaseHeight(int change) {
		this.currentHeight += change;
	}
	public int spaceLeft() {
		return y_size - currentHeight;
	}
	public void start() {
	}
}