package com.jtauber.fop.layout;

import java.util.Vector;
import java.util.Enumeration;

public class BlockArea extends Area {
	
	protected int startIndent;
	protected int endIndent;
	protected int lineHeight;
	protected int lineStackingStrategy; // currently lineHeight

	protected int halfLeading;
	
	protected int align;
	protected int alignLastLine;
	
	private LineArea currentLineArea;

	private String text = "";

	//borders
	
	//padding
	protected int paddingBefore;
	protected int paddingAfter;
	protected int paddingStart;
	protected int paddingEnd;
	public BlockArea(FontState fontState, int allocationWidth, int maxHeight, int startIndent, int endIndent, int align, int alignLastLine, int lineHeight)  {
		super(fontState);
		this.allocationWidth = allocationWidth;
		this.maxHeight = maxHeight;
		this.startIndent = startIndent;
		this.endIndent = endIndent;
		this.fontState = fontState;
		this.align = align;
		this.alignLastLine = alignLastLine;
		this.lineHeight = lineHeight;
		
		this.halfLeading = (lineHeight - fontState.getFontSize())/2;

		this.currentHeight = 0;
	}
	public void addLineArea(LineArea la) {
		int size = la.getHeight();
		this.addChild(la);
		this.text += la.text + "\n";
		this.increaseHeight(size);
	}
	public int addText(FontState fontState, char data[], int start, int end) {
		int ts, te;
		char[] ca;
		
		ts = start;
		te = end;
		ca = data;

		if (currentHeight + currentLineArea.getHeight() > maxHeight) {
			return start;
		}
		
		this.currentLineArea.changeFont(fontState);
		ts = this.currentLineArea.addText(ca,ts,te);
		
		while (ts != -1) {
			this.currentLineArea.align(this.align);
			this.addLineArea(this.currentLineArea);
			this.addDisplaySpace(this.halfLeading);
			this.addDisplaySpace(this.halfLeading);
			this.currentLineArea = new LineArea(fontState,lineHeight,halfLeading,allocationWidth,startIndent,endIndent);
			if (currentHeight + currentLineArea.getHeight() > this.maxHeight) {
				return ts;
			}
			this.currentLineArea.changeFont(fontState);
			ts = this.currentLineArea.addText(ca,ts,te);
		}
		return -1;
	}
	public void end() {
		this.currentLineArea.align(this.alignLastLine);
		this.addLineArea(this.currentLineArea);
		this.addDisplaySpace(this.halfLeading);
	}
	public int spaceLeft() {
		return maxHeight - currentHeight;
	}
	public void start() {
		this.addDisplaySpace(this.halfLeading);
		currentLineArea = new LineArea(fontState, lineHeight, halfLeading, allocationWidth, startIndent, endIndent);
	}
	 void toXML(java.io.PrintWriter writer) {
		writer.println("<BlockArea>");
		java.util.Enumeration e = children.elements();
		while (e.hasMoreElements()) {
			((Box)e.nextElement()).toXML(writer);
		}
		writer.println("</BlockArea>");
	}
}