package com.jtauber.fop.layout;

import java.util.Hashtable;
import java.util.Enumeration;

import com.jtauber.fop.apps.FOPException;

public class FontInfo {

	Hashtable triplets; // look up a font-triplet to find a font-name
	Hashtable fonts; // look up a font-name to get a font (that implements FontMetric at least)
	public FontInfo() {
		
		this.triplets = new Hashtable(); 
		this.fonts = new Hashtable(); 

	}
	public void addFontProperties(String name, String family, String style, String weight) {
		/* add the given family, style and weight as a lookup for the font
		with the given name */

		String key = family + "," + style + "," + weight;
		this.triplets.put(key,name);
	}
	public void addMetrics(String name, FontMetric metrics) {
		// add the given metrics as a font with the given name

		this.fonts.put(name,metrics);
	}
	public String fontLookup(String family, String style, String weight) throws FOPException {
		// given a family, style and weight, return the font name

		String key = family + "," + style + "," + weight;
		String f = (String)this.triplets.get(key);
		if (f == null) {
			throw new FOPException("Unknown font triplet: " + family + " " + style + " " + weight);
		}
		return f;
	}
public Hashtable getFonts() {
	return this.fonts;
}
	public FontMetric getMetricsFor(String fontName) throws FOPException {
		return (FontMetric)fonts.get(fontName);
	}
	public FontMetric getMetricsFor(String family, String style, String weight) throws FOPException {
		// given a family, style and weight, return the metric

		return (FontMetric)fonts.get(fontLookup(family,style,weight));
	}
}