package com.jtauber.fop.layout;

import com.jtauber.fop.apps.FOPException;

public class FontState {
	
	private String fontName;
	private int fontSize;
	private String fontFamily;
	private String fontStyle;
	private String fontWeight;
	private FontMetric metric;
	
	public FontState(FontInfo fontInfo, String fontFamily, String fontStyle, String fontWeight, int fontSize) throws FOPException {
		this.fontFamily = fontFamily;
		this.fontStyle = fontStyle;
		this.fontWeight = fontWeight;
		this.fontSize = fontSize;
		this.fontName = fontInfo.fontLookup(fontFamily,fontStyle,fontWeight);
		this.metric = fontInfo.getMetricsFor(fontName);
	}
	public String getFontName() {
		return this.fontName;
	}
	public int getFontSize() {
		return this.fontSize;
	}
	public int width(int charnum) {
		// returns width of given character number in millipoints
		return fontSize * metric.width(charnum);
	}
}